---
title: Create a unit cost
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Cloud Cost Management
---

> For the complete documentation index, see [llms.txt](https://docs.datadoghq.com/llms.txt).

# Create a unit cost{% #create-a-unit-cost %}
Copy pageCopied
{% tab title="v2" %}
**Note**: This endpoint is in preview and is subject to change. If you have any feedback, contact [Datadog support](https://docs.datadoghq.com/help/).
| Datadog site      | API endpoint                                              |
| ----------------- | --------------------------------------------------------- |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v2/cost/unit_costs |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v2/cost/unit_costs |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v2/cost/unit_costs      |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v2/cost/unit_costs      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v2/cost/unit_costs  |
| uk1.datadoghq.com | POST https://api.uk1.datadoghq.com/api/v2/cost/unit_costs |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v2/cost/unit_costs     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v2/cost/unit_costs |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v2/cost/unit_costs |

### Overview

Create an ROI metric (unit cost) using the given numerator and denominator queries. This endpoint requires the `cloud_cost_management_read` permission.

### Request

#### Body Data (required)



{% tab title="Model" %}

| Parent field      | Field                               | Type     | Description                                                                            |
| ----------------- | ----------------------------------- | -------- | -------------------------------------------------------------------------------------- |
|                   | data [*required*]              | object   | The data object of a unit cost create request.                                         |
| data              | attributes [*required*]        | object   | The attributes of a unit cost create or replace request.                               |
| attributes        | denominator_query [*required*] | object   | A timeseries object containing `queries` and `formulas` arrays.                        |
| denominator_query | formulas [*required*]          | [object] | The list of formulas applied to the queries for this side of the ratio.                |
| denominator_query | queries [*required*]           | [object] | The list of queries evaluated for this side of the ratio.                              |
| attributes        | description                         | string   | An optional description of the unit cost. At most 2000 characters.                     |
| attributes        | name [*required*]              | string   | The name of the unit cost. At most 200 characters.                                     |
| attributes        | numerator_query [*required*]   | object   | A timeseries object containing `queries` and `formulas` arrays.                        |
| numerator_query   | formulas [*required*]          | [object] | The list of formulas applied to the queries for this side of the ratio.                |
| numerator_query   | queries [*required*]           | [object] | The list of queries evaluated for this side of the ratio.                              |
| attributes        | unit_label [*required*]        | string   | The label describing the denominator unit, for example `user`. At most 100 characters. |
| data              | type [*required*]              | enum     | The JSON:API resource type for a unit cost. Allowed enum values: `unit_cost`           |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "denominator_query": {
        "formulas": [
          []
        ],
        "queries": [
          []
        ]
      },
      "description": "Amortized cloud spend divided by the number of active users.",
      "name": "Cloud cost per active user",
      "numerator_query": {
        "formulas": [
          []
        ],
        "queries": [
          []
        ]
      },
      "unit_label": "user"
    },
    "type": "unit_cost"
  }
}
```

{% /tab %}

### Response

{% tab title="201" %}
Created
{% tab title="Model" %}
A response containing a single unit cost.

| Parent field      | Field                               | Type      | Description                                                                                                               |
| ----------------- | ----------------------------------- | --------- | ------------------------------------------------------------------------------------------------------------------------- |
|                   | data [*required*]              | object    | The data object of a unit cost response.                                                                                  |
| data              | attributes [*required*]        | object    | The attributes of a unit cost.                                                                                            |
| attributes        | created_at [*required*]        | date-time | The time the unit cost was created.                                                                                       |
| attributes        | created_by [*required*]        | uuid      | The UUID of the user who created the unit cost.                                                                           |
| attributes        | denominator_query [*required*] | object    | A timeseries object containing `queries` and `formulas` arrays.                                                           |
| denominator_query | formulas [*required*]          | [object]  | The list of formulas applied to the queries for this side of the ratio.                                                   |
| denominator_query | queries [*required*]           | [object]  | The list of queries evaluated for this side of the ratio.                                                                 |
| attributes        | denominator_type [*required*]  | string    | The data source of the denominator queries, or `multisource` when the denominator queries span more than one data source. |
| attributes        | description                         | string    | The description of the unit cost. Omitted when the unit cost has no description.                                          |
| attributes        | name [*required*]              | string    | The name of the unit cost.                                                                                                |
| attributes        | numerator_query [*required*]   | object    | A timeseries object containing `queries` and `formulas` arrays.                                                           |
| numerator_query   | formulas [*required*]          | [object]  | The list of formulas applied to the queries for this side of the ratio.                                                   |
| numerator_query   | queries [*required*]           | [object]  | The list of queries evaluated for this side of the ratio.                                                                 |
| attributes        | org_id [*required*]            | int64     | The ID of the organization the unit cost belongs to.                                                                      |
| attributes        | unit_label [*required*]        | string    | The label describing the denominator unit.                                                                                |
| attributes        | updated_at [*required*]        | date-time | The time the unit cost was last updated.                                                                                  |
| attributes        | updated_by [*required*]        | uuid      | The UUID of the user who last updated the unit cost.                                                                      |
| data              | id [*required*]                | uuid      | The UUID of the unit cost.                                                                                                |
| data              | type [*required*]              | enum      | The JSON:API resource type for a unit cost. Allowed enum values: `unit_cost`                                              |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "created_at": "2026-09-01T18:46:15.933716Z",
      "created_by": "36ea1610-8866-4bd3-bb6d-9bb9fc87cad2",
      "denominator_query": {
        "formulas": [
          []
        ],
        "queries": [
          []
        ]
      },
      "denominator_type": "metrics",
      "description": "Amortized cloud spend divided by the number of active users.",
      "name": "Cloud cost per active user",
      "numerator_query": {
        "formulas": [
          []
        ],
        "queries": [
          []
        ]
      },
      "org_id": 321813,
      "unit_label": "user",
      "updated_at": "2026-09-01T19:52:08.820536Z",
      "updated_by": "13cc0adf-2595-479e-b448-5051c180dddb"
    },
    "id": "64aecd58-e355-4f07-9c3a-56ff6bda6cd8",
    "type": "unit_cost"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \## default
# 
 \# Use a Personal Access Token or Service Access Token export DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>"  \# Curl command curl -X POST "https://api.datadoghq.com/api/v2/cost/unit_costs" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "Authorization: Bearer ${DD_BEARER_TOKEN}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "denominator_query": {
        "formulas": [
          {
            "formula": "denominator"
          }
        ],
        "queries": [
          {
            "data_source": "metrics",
            "name": "denominator",
            "query": "avg:system.cpu.user{*}"
          }
        ],
        "response_format": "timeseries"
      },
      "name": "Cloud cost per active user",
      "numerator_query": {
        "formulas": [
          {
            "formula": "numerator"
          }
        ],
        "queries": [
          {
            "data_source": "cloud_cost",
            "name": "numerator",
            "query": "sum:aws.cost.net.amortized.shared.resources.allocated{*}.rollup(sum, daily)"
          }
        ],
        "response_format": "timeseries"
      },
      "unit_label": "user"
    },
    "type": "unit_cost"
  }
}
EOF 
                
##### 

```python
"""
Create a unit cost returns "Created" response
"""

from os import environ
from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.cloud_cost_management_api import CloudCostManagementApi
from datadog_api_client.v2.model.unit_cost_create_request import UnitCostCreateRequest
from datadog_api_client.v2.model.unit_cost_create_request_data import UnitCostCreateRequestData
from datadog_api_client.v2.model.unit_cost_formula import UnitCostFormula
from datadog_api_client.v2.model.unit_cost_query import UnitCostQuery
from datadog_api_client.v2.model.unit_cost_query_definition import UnitCostQueryDefinition
from datadog_api_client.v2.model.unit_cost_request_attributes import UnitCostRequestAttributes
from datadog_api_client.v2.model.unit_cost_type import UnitCostType

body = UnitCostCreateRequest(
    data=UnitCostCreateRequestData(
        attributes=UnitCostRequestAttributes(
            denominator_query=UnitCostQueryDefinition(
                formulas=[
                    UnitCostFormula([("formula", "numerator")]),
                ],
                queries=[
                    UnitCostQuery(
                        [
                            ("data_source", "cloud_cost"),
                            ("name", "numerator"),
                            ("query", "sum:aws.cost.net.amortized.shared.resources.allocated{*}.rollup(sum, daily)"),
                        ]
                    ),
                ],
            ),
            description="Amortized cloud spend divided by the number of active users.",
            name="Cloud cost per active user",
            numerator_query=UnitCostQueryDefinition(
                formulas=[
                    UnitCostFormula([("formula", "numerator")]),
                ],
                queries=[
                    UnitCostQuery(
                        [
                            ("data_source", "cloud_cost"),
                            ("name", "numerator"),
                            ("query", "sum:aws.cost.net.amortized.shared.resources.allocated{*}.rollup(sum, daily)"),
                        ]
                    ),
                ],
            ),
            unit_label="user",
        ),
        type=UnitCostType.UNIT_COST,
    ),
)

configuration = Configuration()
configuration.access_token = environ["DD_BEARER_TOKEN"]
configuration.unstable_operations["create_unit_cost"] = True
with ApiClient(configuration) as api_client:
    api_instance = CloudCostManagementApi(api_client)
    response = api_instance.create_unit_cost(body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" python3 "example.py"
##### 

```ruby
# Create a unit cost returns "Created" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.access_token = ENV["DD_BEARER_TOKEN"]
  config.unstable_operations["v2.create_unit_cost".to_sym] = true
end
api_instance = DatadogAPIClient::V2::CloudCostManagementAPI.new

body = DatadogAPIClient::V2::UnitCostCreateRequest.new({
  data: DatadogAPIClient::V2::UnitCostCreateRequestData.new({
    attributes: DatadogAPIClient::V2::UnitCostRequestAttributes.new({
      denominator_query: DatadogAPIClient::V2::UnitCostQueryDefinition.new({
        formulas: [
          DatadogAPIClient::V2::UnitCostFormula.new({}),
        ],
        queries: [
          DatadogAPIClient::V2::UnitCostQuery.new({}),
        ],
      }),
      description: "Amortized cloud spend divided by the number of active users.",
      name: "Cloud cost per active user",
      numerator_query: DatadogAPIClient::V2::UnitCostQueryDefinition.new({
        formulas: [
          DatadogAPIClient::V2::UnitCostFormula.new({}),
        ],
        queries: [
          DatadogAPIClient::V2::UnitCostQuery.new({}),
        ],
      }),
      unit_label: "user",
    }),
    type: DatadogAPIClient::V2::UnitCostType::UNIT_COST,
  }),
})
p api_instance.create_unit_cost(body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" rb "example.rb"
##### 

```go
// Create a unit cost returns "Created" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.UnitCostCreateRequest{
		Data: datadogV2.UnitCostCreateRequestData{
			Attributes: datadogV2.UnitCostRequestAttributes{
				DenominatorQuery: datadogV2.UnitCostQueryDefinition{
					Formulas: []map[string]interface{}{
						map[string]interface{}{
							"formula": "numerator",
						},
					},
					Queries: []map[string]interface{}{
						map[string]interface{}{
							"data_source": "cloud_cost",
							"name":        "numerator",
							"query":       "sum:aws.cost.net.amortized.shared.resources.allocated{*}.rollup(sum, daily)",
						},
					},
				},
				Description: *datadog.NewNullableString(datadog.PtrString("Amortized cloud spend divided by the number of active users.")),
				Name:        "Cloud cost per active user",
				NumeratorQuery: datadogV2.UnitCostQueryDefinition{
					Formulas: []map[string]interface{}{
						map[string]interface{}{
							"formula": "numerator",
						},
					},
					Queries: []map[string]interface{}{
						map[string]interface{}{
							"data_source": "cloud_cost",
							"name":        "numerator",
							"query":       "sum:aws.cost.net.amortized.shared.resources.allocated{*}.rollup(sum, daily)",
						},
					},
				},
				UnitLabel: "user",
			},
			Type: datadogV2.UNITCOSTTYPE_UNIT_COST,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	ctx = context.WithValue(ctx, datadog.ContextAccessToken, os.Getenv("DD_BEARER_TOKEN"))
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.CreateUnitCost", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewCloudCostManagementApi(apiClient)
	resp, r, err := api.CreateUnitCost(ctx, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `CloudCostManagementApi.CreateUnitCost`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `CloudCostManagementApi.CreateUnitCost`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" go run "main.go"
##### 

```java
// Create a unit cost returns "Created" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.CloudCostManagementApi;
import com.datadog.api.client.v2.model.UnitCostCreateRequest;
import com.datadog.api.client.v2.model.UnitCostCreateRequestData;
import com.datadog.api.client.v2.model.UnitCostQueryDefinition;
import com.datadog.api.client.v2.model.UnitCostRequestAttributes;
import com.datadog.api.client.v2.model.UnitCostResponse;
import com.datadog.api.client.v2.model.UnitCostType;
import java.util.Collections;
import java.util.Map;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setAccessToken(System.getenv("DD_BEARER_TOKEN"));
    defaultClient.setUnstableOperationEnabled("v2.createUnitCost", true);
    CloudCostManagementApi apiInstance = new CloudCostManagementApi(defaultClient);

    UnitCostCreateRequest body =
        new UnitCostCreateRequest()
            .data(
                new UnitCostCreateRequestData()
                    .attributes(
                        new UnitCostRequestAttributes()
                            .denominatorQuery(
                                new UnitCostQueryDefinition()
                                    .formulas(
                                        Collections.singletonList(
                                            Map.ofEntries(Map.entry("formula", "numerator"))))
                                    .queries(
                                        Collections.singletonList(
                                            Map.ofEntries(
                                                Map.entry("data_source", "cloud_cost"),
                                                Map.entry("name", "numerator"),
                                                Map.entry(
                                                    "query",
                                                    "sum:aws.cost.net.amortized.shared.resources.allocated{*}.rollup(sum,"
                                                        + " daily)")))))
                            .description(
                                "Amortized cloud spend divided by the number of active users.")
                            .name("Cloud cost per active user")
                            .numeratorQuery(
                                new UnitCostQueryDefinition()
                                    .formulas(
                                        Collections.singletonList(
                                            Map.ofEntries(Map.entry("formula", "numerator"))))
                                    .queries(
                                        Collections.singletonList(
                                            Map.ofEntries(
                                                Map.entry("data_source", "cloud_cost"),
                                                Map.entry("name", "numerator"),
                                                Map.entry(
                                                    "query",
                                                    "sum:aws.cost.net.amortized.shared.resources.allocated{*}.rollup(sum,"
                                                        + " daily)")))))
                            .unitLabel("user"))
                    .type(UnitCostType.UNIT_COST));

    try {
      UnitCostResponse result = apiInstance.createUnitCost(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling CloudCostManagementApi#createUnitCost");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" java "Example.java"
##### 

```rust
// Create a unit cost returns "Created" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_cloud_cost_management::CloudCostManagementAPI;
use datadog_api_client::datadogV2::model::UnitCostCreateRequest;
use datadog_api_client::datadogV2::model::UnitCostCreateRequestData;
use datadog_api_client::datadogV2::model::UnitCostQueryDefinition;
use datadog_api_client::datadogV2::model::UnitCostRequestAttributes;
use datadog_api_client::datadogV2::model::UnitCostType;
use serde_json::Value;
use std::collections::BTreeMap;

#[tokio::main]
async fn main() {
    let body =
        UnitCostCreateRequest::new(
            UnitCostCreateRequestData::new(
                UnitCostRequestAttributes::new(
                    UnitCostQueryDefinition::new(
                        vec![BTreeMap::from([("formula".to_string(), Value::from("numerator"))])],
                        vec![
                            BTreeMap::from(
                                [
                                    ("data_source".to_string(), Value::from("cloud_cost")),
                                    ("name".to_string(), Value::from("numerator")),
                                    (
                                        "query".to_string(),
                                        Value::from(
                                            "sum:aws.cost.net.amortized.shared.resources.allocated{*}.rollup(sum, daily)",
                                        ),
                                    ),
                                ],
                            )
                        ],
                    ),
                    "Cloud cost per active user".to_string(),
                    UnitCostQueryDefinition::new(
                        vec![BTreeMap::from([("formula".to_string(), Value::from("numerator"))])],
                        vec![
                            BTreeMap::from(
                                [
                                    ("data_source".to_string(), Value::from("cloud_cost")),
                                    ("name".to_string(), Value::from("numerator")),
                                    (
                                        "query".to_string(),
                                        Value::from(
                                            "sum:aws.cost.net.amortized.shared.resources.allocated{*}.rollup(sum, daily)",
                                        ),
                                    ),
                                ],
                            )
                        ],
                    ),
                    "user".to_string(),
                ).description(Some("Amortized cloud spend divided by the number of active users.".to_string())),
                UnitCostType::UNIT_COST,
            ),
        );
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.CreateUnitCost", true);
    let api = CloudCostManagementAPI::with_config(configuration);
    let resp = api.create_unit_cost(body).await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" cargo run
##### 

```typescript
/**
 * Create a unit cost returns "Created" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration({
  authMethods: {
    AuthZ: {
      accessToken: process.env.DD_BEARER_TOKEN as string,
    },
  },
});
configuration.unstableOperations["v2.createUnitCost"] = true;
const apiInstance = new v2.CloudCostManagementApi(configuration);

const params: v2.CloudCostManagementApiCreateUnitCostRequest = {
  body: {
    data: {
      attributes: {
        denominatorQuery: {
          formulas: [
            {
              formula: "numerator",
            },
          ],
          queries: [
            {
              data_source: "cloud_cost",
              name: "numerator",
              query:
                "sum:aws.cost.net.amortized.shared.resources.allocated{*}.rollup(sum, daily)",
            },
          ],
        },
        description:
          "Amortized cloud spend divided by the number of active users.",
        name: "Cloud cost per active user",
        numeratorQuery: {
          formulas: [
            {
              formula: "numerator",
            },
          ],
          queries: [
            {
              data_source: "cloud_cost",
              name: "numerator",
              query:
                "sum:aws.cost.net.amortized.shared.resources.allocated{*}.rollup(sum, daily)",
            },
          ],
        },
        unitLabel: "user",
      },
      type: "unit_cost",
    },
  },
};

apiInstance
  .createUnitCost(params)
  .then((data: v2.UnitCostResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" tsc "example.ts"
{% /tab %}
